//  
import java.awt.*;
import java.net.*;
import java.io.*;
import java.awt.event.*;
import java.util.*;
//
//coach's brain
//
class CoachBrain {

	//for formation wideness
	static final int NORMAL = 0;
	static final int WIDE   = 1;
	static final int NARROW = 2;
	int wideness;


	double ball_var_Y;
        double ball_ave_Y;

      /*****************************************/
      /*              field                    */
      /*****************************************/

       MainWindow mw;
       AnalyzeInfo aInfo;
       CPort cPort;
       Formation form;
       CoachPhase cp;

	//for calc evaluation value
       int myKick = 0;
       int eneKick = 0;
       int myScore = 0;
       int eneScore = 0;
       int myKick0, eneKick0, myScore0, eneScore0;

       int numberOfCoach = 0;

       int sayCount = 0;

       Vector vect ;

	//I said message at once ?
       boolean isCoached = false;

	// analyzed item 
	//
       Eval eva;
       BallPos bp;
       Shihairitsu sr;

	//for record log file
        FileOutputStream fo;
        PrintWriter fop;

	/*************************************************/
	/*                constructor                    */
	/*************************************************/
        public CoachBrain(AnalyzeInfo aInfo, CPort cPort){       
       
                this.aInfo = aInfo;
                this.cPort = cPort;
        
                form = new Formation();
        
                vect = new Vector();
       
                //initialize
                vect.add(new CoachPhase(0,0,new Eval(0), new BallPos(50), new Shihairitsu(50) ,Formation.NORMAL_POS));

                if (CParam.recordLog){
  
                        openLogFile();
                
                }
                
        }

    	public CoachBrain(MainWindow mw, AnalyzeInfo aInfo, CPort cPort){		
		this.mw = mw;
		this.aInfo = aInfo;
		this.cPort = cPort;

		form = new Formation();
		
		vect = new Vector(20);

		//initialize
		vect.add(new CoachPhase(0,0,new Eval(0), new BallPos(50), new Shihairitsu(50) ,Formation.NORMAL_POS));

                if (CParam.recordLog){
        
                        openLogFile();
         
                }

	}	

	/*****************************************************/
	/*                    method                         */
	/*****************************************************/ 

	//ؼƤͤ
        //kokode hyoukachi kara say suru position wo kimeru
	//if return value is true, coach said.
	//otherwise (false) coach do not say.

	protected boolean think(){

		boolean doIsay = true;
		cp =  (CoachPhase)vect.lastElement();

		int currentTime = aInfo.getTime();

		System.out.println("currentTime"+currentTime);
		System.out.println("beforeTime"+cp.endTime);

		if (currentTime - cp.endTime <= 150){

			return false;

		}

		/***********************************************/
		/*    evaluate at play_on                      */
		/***********************************************/

		eva = new Eval(calcEval(cp, currentTime), currentTime);

		bp = new BallPos(aInfo.bpAna.getBallInRightRate(), currentTime);

		if ((aInfo.shihaiRight == 0) &&( aInfo.shihaiLeft == 0)){
			sr = new  Shihairitsu(50.0, currentTime);

		}else{

			sr = new Shihairitsu((double)aInfo.shihaiLeft / (aInfo.shihaiRight + aInfo.shihaiLeft) * 100, currentTime);

		}

		/***************************************************/
		/*       					   */
		/***************************************************/
		CoachPhase ccp = new CoachPhase(cp.endTime, currentTime,
					 eva, bp, sr,form.getFormationType()); 

		vect.add(ccp);

		/********************************************/
		/*   					    */
		/*                                          */
		/********************************************/
		
		ball_var_Y = aInfo.getBallVarienceY(cp.endTime, currentTime);
		ball_ave_Y = aInfo.getBallAverageY(cp.endTime, currentTime);

		System.out.println(ball_var_Y);

		if(ball_var_Y >= 5.0){

			wideness = WIDE;

		}else if ((ball_var_Y <= 1.0) && (ball_ave_Y <= 5) && (ball_ave_Y >= -5)){

			wideness = NARROW;

		}else{
			
			wideness = NORMAL;
		}

		if (!isCoached){

		myKick = myKick0;
                eneKick = eneKick0;
                myScore = myScore0;
                eneScore = eneScore0;

		    doIsay = firstCoach(myScore - eneScore);

		}else{

		    doIsay = hyouka(cp, vect);
		    
		}

		//keisei no hyouji
		
		if (mw != null){
		
			mw.kg.draw(currentTime, cp.eval, ccp.eval);
			mw.kg.draw(currentTime, cp.bp, ccp.bp);

			mw.kg.draw(currentTime, cp.sr, ccp.sr);
		}


                myKick = myKick0;
                eneKick = eneKick0;
                myScore = myScore0;
                eneScore = eneScore0;

		return doIsay;

	}

	private double calcEval(CoachPhase cp, int currentTime){

		myKick0 = aInfo.getTeamKickCount(CParam.CType_LEFT);
                eneKick0 = aInfo.getTeamKickCount(CParam.CType_RIGHT);   
                myScore0 = aInfo.getScore(0);
                eneScore0 = aInfo.getScore(1);

                double eval = ((myKick0 - myKick) + (myScore0 - myScore) * 5
                     -  (eneKick0 - eneKick) - (eneScore0 - eneScore) * 5)
                        / (currentTime - cp.endTime);
		System.out.println("eval"+eval);
		return eval;

	}

	private void openLogFile(){
        
                try{
        
                    fo = new FileOutputStream(CParam.logName);
                    fop = new PrintWriter(fo);
                        
                }
                catch(IOException e){
                                e.printStackTrace();
                }

        }

	public void close(){

		think();

		fop.close();

	}
	public void say(int sayCount){

   	     	int start,end;          
		start = end = 0;     

		//first coach
     		if (sayCount == 3){

		    start = 0;
                    end  = 3;
		//second coach
	       	}else if (sayCount == 2){

                	start = 4;
                	end  = 7;			
		//third coach
            	}else if (sayCount == 1){

                	start = 8;
                	end  = 10;			
			
            	}

        	sayMessage(start, end);   


	}

	//
	//return value is "Will I say?"
	//

	private boolean firstCoach(int diffScore){
	    
	    	  if (diffScore>= 1){
		    
                    isCoached = true;
		    coachOffensive();
		    if(CParam.recordLog){
			try{
				writeHeader();
				writeCoachData();

			}catch(IOException e){
				e.printStackTrace(); 
			}
		    }

		    return true;

		  } else if (diffScore <= -1){
		    
		    isCoached = true;
		    coachDeffensive();
			
                    if(CParam.recordLog){
                        try{
                                writeHeader();
                                writeCoachData();
			
                        }catch(IOException e){
                                e.printStackTrace();
                        }
		     }
		     return true;	

      		  } 
	      	  //because the score is equal, I don't say
		  return false;
	}
        
	private void writeHeader() throws IOException {

		//System.out.println("this is write header");

		fop.println("*******coach log **********");
		fop.println("log file name :"+CParam.logName);
		fop.println("MyTeamName\t"+aInfo.getTeamName(CParam.CType_LEFT));
		fop.println("EnemyTeamName\t"+aInfo.getTeamName(CParam.CType_RIGHT)); 	
		fop.println("evalCalc:eval = (myKick0 - myKick) + (myScore0 - myScore) * 5 -  (eneKick0 - eneKick) - (eneScore0 - eneScore) * / (currentTime - cp.endTime");


		fop.println("coachCount\time\tinc_myScore\tinc_eneScore\tinc_myKick\tinc_eneKick\t"
		+"eval\tballlocation(%)\tballcontrolelate(%)\tballAverageY\tballBunsanY\t"
		+"coachFormation");

	}

    private void writeCoachData() throws IOException {

                fop.println(numberOfCoach+"\t"+aInfo.getTime()+"\t"+(myScore0-myScore)+
		"\t"+(eneScore0 - eneScore)+"\t"+(myKick0 - myKick)+"\t"+(eneKick0 - eneKick)+
		"\t"+eva.eval+"\t"+bp.ballInMySideRate+"\t"+sr.shihairitsu+"\t"+ball_ave_Y+
		"\t"+ball_var_Y+"\t"+form.getFormationName());
  
    }

    private boolean hyouka(CoachPhase ccp ,Vector vect){

	//CoachPhase cp =  (CoachPhase)vect.lastElement();

	double[] eval = new double[3];

	int[] count = new int[3];

	CoachPhase cp ;

	double maxEval = -100000;
	int maxIndex = 0;

	Enumeration e = vect.elements();
	//first element is a dummy data.
	e.nextElement();

	for (; e.hasMoreElements(); ){

		cp = (CoachPhase)e.nextElement();		

		switch ((int)(cp.coachMode/3)){				

			case 0:    //normal 

				eval[0] += cp.eval.eval;
				count[0]++;
				continue; 
	
			case 1:    // defensive 
		
				eval[1] += cp.eval.eval;
				count[1]++;
				continue;	
			case 2:    // offensive

				eval[2] += cp.eval.eval;
				count[2]++;
				continue;
		}
	}
		
	for (int i=0; i <= 2; i++){

		if (count[i] !=0){
                       //calc average
       	                eval[i] = eval[i] / count[i];
			
		}else{
			//count is 0
			eval[i] = 0;
		}
		
		if(maxEval <  eval[i]){
			maxEval = eval[i];
			maxIndex = i;
		}
	}


	if(mw != null){

		mw.formNormalEval.setText(new Integer((int)eval[0]).toString());
		mw.formDefensiveEval.setText(new Integer((int)eval[1]).toString());
		mw.formOffensiveEval.setText(new Integer((int)eval[2]).toString());
	}

	System.out.println("normal eval:"+new Integer((int)eval[0]).toString());
	System.out.println("defensive eval:"+new Integer((int)eval[1]).toString());
	System.out.println("offensive eval:"+new Integer((int)eval[2]).toString());
	System.out.println("coach "+form.getFormationName());


	if (form.getFormationType() == maxIndex*3+wideness){

		if(CParam.recordLog){
                        try{
                                writeCoachData();
                        }catch(IOException ie){
                                ie.printStackTrace();
			}
		
		}

		return false;

	}else{

		 if(CParam.recordLog){

			try{
                        	writeCoachData();
			}catch(IOException ie){
				ie.printStackTrace();
			}

                }

		numberOfCoach++;
		form.setFormationType(maxIndex*3+wideness);
		return true;
	}

    }


    private void coachDeffensive(){

	form.setFormationType(Formation.DEFENSIVE_POS + wideness);

	numberOfCoach++;
		
    }
    private void coachOffensive(){
 
	form.setFormationType(Formation.OFFENSIVE_POS + wideness);

	numberOfCoach++;

   }
    private void coachNormal(){
	
	form.setFormationType(Formation.NORMAL_POS + wideness);

	numberOfCoach++;
    }
	
	protected void sayEnemyPlayerMark(int myUnum, int eneUnum,
					double x, double y, String message){
		int reverce = 1;

		if (!cPort.myTeamIsLeft){
			reverce = -1;
		}
		message = message  
			+" " + new Integer(myUnum).toString()
			+ " m"
			+ " " + new Integer(eneUnum).toString()
			+ " " + new Integer(doublex10toInt(x * reverce)).toString()
			+ " " + new Integer(doublex10toInt(y)).toString();
	}


  //
  //sptartUnumendUnumޤǤ̣Υץ졼˻ؼ
  //ؼƤϡanalyzedPlayer饹˵ҡ
  //
         public void sayMessage(int startUnum, int endUnum){
	     		
	     double[] position = new double[6];
	     
		//header
	     String message = "(say kas";

	     for (int i = startUnum; i <= endUnum; i++){
       
		   position =  aInfo.anaPlayer[i].getPosition();
		   message = message + " " +new Integer(i+1).toString();

		   if (aInfo.anaPlayer[i].status != 1){

		     message = message + " z";
		     message = message + " " + position2String(position);		
		   }else {

		       sayManMark(i, message);

		   }

 
	     }
		//saigoni dokono position kawo okuru
	     if(endUnum == 10){

		message = message + " 12 ";

		int type = (int)(form.getFormationType()/3);

		for(int k = 0; k <= 10; k++){

		 	message = message + 
			new Integer(form.kickLocation[type][k]).toString()
			+ " "; 
		}

		//System.out.println(message);

	}

	     message = message + ")";

	     cPort.send_info(message);

	     sayCount++;
	     System.out.println(message);

	 }

    private void sayManMark(int myUnum, String message){
		 
      //temporary
      //int myUnum = 3;
      int eneUnum = 3;
      double eneX = 0.0;
      double eneY = 0.0;

      message = message + " m";
      message = message + " "+ new Integer(eneUnum).toString();
      message = message + " "+new Integer(doublex10toInt(eneX)).toString();
      message = message + " "+new Integer(doublex10toInt(eneY)).toString();

    }

	/******************************************/
	/*    utilities   for  sending message    */
	/******************************************/

	public String position2String(double[] d) 
		throws IllegalArgumentException{

		String message = " ";
		int reverce = 1;

		if(! (d.length == 6)){

			new IllegalArgumentException();

		}			 
			for(int i = 0; i<= d.length-1; i++){
				if (!cPort.myTeamIsLeft){
					reverce = -reverce;
				}
				
				
				message = message + new Integer(doublex10toInt(d[i] * reverce)).toString()+" "; 		
							
		}				
		return message.trim();


		}
	
	protected int doublex10toInt(double d){

		return (int)(d*10);

	}

}
	
